Package org.springframework.web.servlet.mvc

# Class UrlFilenameViewController

java.lang.Object
org.springframework.context.support.ApplicationObjectSupport
org.springframework.web.context.support.WebApplicationObjectSupport
org.springframework.web.servlet.support.WebContentGenerator
org.springframework.web.servlet.mvc.AbstractController
org.springframework.web.servlet.mvc.AbstractUrlViewController
org.springframework.web.servlet.mvc.UrlFilenameViewController

All Implemented Interfaces:
  `org.springframework.beans.factory.Aware`, `org.springframework.context.ApplicationContextAware`, `org.springframework.web.context.ServletContextAware`, `Controller`

public class UrlFilenameViewController extends AbstractUrlViewController
Simple `Controller` implementation that transforms the virtual path of a URL into a view name and returns that view.

Can optionally prepend a `prefix` and/or append a `suffix` to build the viewname from the URL filename.

Find some examples below:

1. `"/index" -> "index"`
2. `"/index.html" -> "index"`
3. `"/index.html"` + prefix `"pre_"` and suffix `"_suf" -> "pre_index_suf"`
4. `"/products/view.html" -> "products/view"`

Thanks to David Barri for suggesting prefix/suffix support!

Author:
  Alef Arendsen, Juergen Hoeller, Rob Harrop
See Also:
  - `setPrefix(java.lang.String)`
  - `setSuffix(java.lang.String)`

## Field Summary

### Fields inherited from class org.springframework.web.servlet.support.WebContentGenerator

`HEADER_CACHE_CONTROL, METHOD_GET, METHOD_HEAD, METHOD_POST`

### Fields inherited from class org.springframework.context.support.ApplicationObjectSupport

`logger`

## Constructor Summary

Constructors
Constructor
Description
`UrlFilenameViewController()`

## Method Summary

Modifier and Type
Method
Description
`protected String`
`extractOperableUrl(HttpServletRequest request)`
Extract a URL path from the given request, suitable for view name extraction.
`protected String`
`extractViewNameFromUrlPath(String uri)`
Extract the URL filename from the given request URI.
`protected String`
`getPrefix()`
Return the prefix to prepend to the request URL filename.
`protected String`
`getSuffix()`
Return the suffix to append to the request URL filename.
`protected String`
`getViewNameForRequest(HttpServletRequest request)`
Returns view name based on the URL filename, with prefix/suffix applied when appropriate.
`protected String`
`getViewNameForUrlPath(String uri)`
Returns view name based on the URL filename, with prefix/suffix applied when appropriate.
`protected String`
`postProcessViewName(String viewName)`
Build the full view name based on the given view name as indicated by the URL path.
`void`
`setPrefix(String prefix)`
Set the prefix to prepend to the request URL filename to build a view name.
`void`
`setSuffix(String suffix)`
Set the suffix to append to the request URL filename to build a view name.

### Methods inherited from class org.springframework.web.servlet.mvc.AbstractUrlViewController

`getUrlPathHelper, handleRequestInternal, setAlwaysUseFullPath, setRemoveSemicolonContent, setUrlDecode, setUrlPathHelper`

### Methods inherited from class org.springframework.web.servlet.mvc.AbstractController

`handleRequest, isSynchronizeOnSession, setSynchronizeOnSession`

### Methods inherited from class org.springframework.web.servlet.support.WebContentGenerator

`applyCacheControl, applyCacheSeconds, checkAndPrepare, checkRequest, getAllowHeader, getCacheControl, getCacheSeconds, getSupportedMethods, getVaryByRequestHeaders, isRequireSession, prepareResponse, setCacheControl, setCacheSeconds, setRequireSession, setSupportedMethods, setVaryByRequestHeaders`

### Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport

`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

### Methods inherited from class org.springframework.context.support.ApplicationObjectSupport

`getApplicationContext, getMessageSourceAccessor, initApplicationContext, obtainApplicationContext, requiredContextClass, setApplicationContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### UrlFilenameViewController

public UrlFilenameViewController()

## Method Details

### setPrefix

public void setPrefix(@Nullable String prefix)
Set the prefix to prepend to the request URL filename to build a view name.

### getPrefix

protected String getPrefix()
Return the prefix to prepend to the request URL filename.

### setSuffix

public void setSuffix(@Nullable String suffix)
Set the suffix to append to the request URL filename to build a view name.

### getSuffix

protected String getSuffix()
Return the suffix to append to the request URL filename.

### getViewNameForRequest

protected String getViewNameForRequest(HttpServletRequest request)
Returns view name based on the URL filename, with prefix/suffix applied when appropriate.

Specified by:
  `getViewNameForRequest` in class `AbstractUrlViewController`
Parameters:
  `request` - current HTTP request
Returns:
  a view name for this request (never `null`)
See Also:
  - `extractViewNameFromUrlPath(java.lang.String)`
  - `setPrefix(java.lang.String)`
  - `setSuffix(java.lang.String)`

### extractOperableUrl

protected String extractOperableUrl(HttpServletRequest request)
Extract a URL path from the given request, suitable for view name extraction.

Parameters:
  `request` - current HTTP request
Returns:
  the URL to use for view name extraction

### getViewNameForUrlPath

protected String getViewNameForUrlPath(String uri)
Returns view name based on the URL filename, with prefix/suffix applied when appropriate.

Parameters:
  `uri` - the request URI; for example `"/index.html"`
Returns:
  the extracted URI filename; for example `"index"`
See Also:
  - `extractViewNameFromUrlPath(java.lang.String)`
  - `postProcessViewName(java.lang.String)`

### extractViewNameFromUrlPath

protected String extractViewNameFromUrlPath(String uri)
Extract the URL filename from the given request URI.

Parameters:
  `uri` - the request URI; for example `"/index.html"`
Returns:
  the extracted URI filename; for example `"index"`

### postProcessViewName

protected String postProcessViewName(String viewName)
Build the full view name based on the given view name as indicated by the URL path.

The default implementation simply applies prefix and suffix. This can be overridden, for example, to manipulate upper case / lower case, etc.

Parameters:
  `viewName` - the original view name, as indicated by the URL path
Returns:
  the full view name to use
See Also:
  - `getPrefix()`
  - `getSuffix()`